Attribute VB_Name = "modIni"
Option Explicit

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" ( _
                        ByVal lpApplicationName As String, _
                        ByVal lpKeyName As Any, _
                        ByVal lpString As Any, _
                        ByVal lpFileName As String) As Long
                        
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" ( _
                        ByVal lpApplicationName As String, _
                        ByVal lpKeyName As Any, _
                        ByVal lpDefault As String, _
                        ByVal lpReturnedString As String, _
                        ByVal nSize As Long, _
                        ByVal lpFileName As String) As Long
                        
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" ( _
                        ByVal lpAppName As String, _
                        ByVal lpReturnedString As String, _
                        ByVal nSize As Long, _
                        ByVal lpFileName As String) As Long

Public Sub SaveToIni(strSection As String, _
                    strKey As String, _
                    strData As String)
    Dim strFileName As String
    Dim lngRetVal As Long
    
    strFileName = App.path & "\" & App.EXEName & ".ini"
    lngRetVal = WritePrivateProfileString(strSection, _
                                            strKey, _
                                            strData, _
                                            strFileName)
End Sub

Public Sub SaveToIniEx(strFileName As String, _
                    strSection As String, _
                    strKey As String, _
                    strData As String)
    Dim lngRetVal As Long
    lngRetVal = WritePrivateProfileString(strSection, _
                                            strKey, _
                                            strData, _
                                            strFileName)
End Sub

Public Function GetFromIni(strSection As String, _
                        strKey As String, _
                        Optional strDefault As String) As String
    Dim lngRetVal As Long
    Dim lngBuffSz As Long
    Dim strBuff As String
    Dim strFileName As String
    
    strFileName = App.path & "\" & App.EXEName & ".ini"
    strBuff = Space(255)
    lngBuffSz = 255
    lngRetVal = GetPrivateProfileString(strSection, _
                                        strKey, _
                                        strDefault, _
                                        strBuff, _
                                        lngBuffSz, _
                                        strFileName)
    lngBuffSz = InStr(1, strBuff, Chr(0), vbBinaryCompare)
    If lngBuffSz > 0 Then
        GetFromIni = Trim(Left(strBuff, lngBuffSz - 1))
    Else
        GetFromIni = strBuff
    End If
End Function

Public Function GetFromIniEx(strFileName As String, _
                        strSection As String, _
                        strKey As String, _
                        Optional strDefault As String) As String
    Dim lngRetVal As Long
    Dim lngBuffSz As Long
    Dim strBuff As String
    
    strBuff = Space(255)
    lngBuffSz = 255
    lngRetVal = GetPrivateProfileString(strSection, _
                                        strKey, _
                                        strDefault, _
                                        strBuff, _
                                        lngBuffSz, _
                                        strFileName)
    lngBuffSz = InStr(1, strBuff, Chr(0), vbBinaryCompare)
    If lngBuffSz > 0 Then
        GetFromIniEx = Trim(Left(strBuff, lngBuffSz - 1))
    Else
        GetFromIniEx = strBuff
    End If
End Function

Public Function GetAllIniSettings(Section As String) As Variant
    Dim lRet As Long
    Dim path As String
    Dim AppName As String
    Dim strTemp As String
    Dim Table() As String
    Dim Table2() As String
    Dim iPnt As Integer
    Dim iPnt2 As Integer
    Dim iPosit As Integer

    strTemp = Space(32567)
    path = App.path

    If Right(path, 1) <> "\" Then
        path = path & "\"
    End If

    AppName = App.EXEName

    lRet = GetPrivateProfileSection(Section, strTemp, Len(strTemp), path & AppName & ".ini")
    iPnt = 0
    'For Redim+Preserve tables only the las index can be changed
    If Left(strTemp, 2) = Chr$(0) & Chr$(0) Then
        Exit Function
    End If

    If (lRet = 0) Then
        Exit Function
    End If

    Do While Left(strTemp, 1) <> Chr$(0)
        ReDim Preserve Table(1, iPnt)
        iPosit = InStr(strTemp, "=")
        Table(0, iPnt) = Left$(strTemp, iPosit - 1)
        strTemp = Mid$(strTemp, iPosit + 1)
        iPosit = InStr(strTemp, Chr$(0))
        Table(1, iPnt) = Left$(strTemp, iPosit - 1)
        strTemp = Mid$(strTemp, iPosit + 1)
        iPnt = iPnt + 1
    Loop
    ReDim Table2(iPnt - 1, 1)

    For iPnt2 = 0 To iPnt - 1
        Table2(iPnt2, 0) = Table(0, iPnt2)
        Table2(iPnt2, 1) = Table(1, iPnt2)
    Next

    GetAllIniSettings = Table2
End Function

Public Function GetAllIniSettingsEx(strFileName As String, Section As String) As Variant
    Dim lRet As Long
    Dim strTemp As String
    Dim Table() As String
    Dim Table2() As String
    Dim iPnt As Integer
    Dim iPnt2 As Integer
    Dim iPosit As Integer
    
    strTemp = Space(32567)
    lRet = GetPrivateProfileSection(Section, strTemp, Len(strTemp), strFileName)
    iPnt = 0
    'For Redim+Preserve tables only the las index can be changed
    If Left(strTemp, 2) = Chr$(0) & Chr$(0) Then
        Exit Function
    End If
    
    If (lRet = 0) Then
        Exit Function
    End If
    
    Do While Left(strTemp, 1) <> Chr$(0)
        ReDim Preserve Table(1, iPnt)
        iPosit = InStr(strTemp, "=")
        Table(0, iPnt) = Left$(strTemp, iPosit - 1)
        strTemp = Mid$(strTemp, iPosit + 1)
        iPosit = InStr(strTemp, Chr$(0))
        Table(1, iPnt) = Left$(strTemp, iPosit - 1)
        strTemp = Mid$(strTemp, iPosit + 1)
        iPnt = iPnt + 1
    Loop
    ReDim Table2(iPnt - 1, 1)
    
    For iPnt2 = 0 To iPnt - 1
        Table2(iPnt2, 0) = Table(0, iPnt2)
        Table2(iPnt2, 1) = Table(1, iPnt2)
    Next
    
    GetAllIniSettingsEx = Table2
End Function

Public Function DeleteIniSetting(Section As String, Optional Key As String)
    Dim lRet As Long
    Dim path As String
    Dim AppName As String
    path = App.path
    AppName = App.EXEName

    If Right(path, 1) <> "\" Then
        path = path & "\"
    End If
    If Key = "" Then
        lRet = WritePrivateProfileString(Section, vbNullString, vbNullString, path & AppName & ".ini")
    Else
        lRet = WritePrivateProfileString(Section, Key, vbNullString, path & AppName & ".ini")
    End If
End Function

Public Function DeleteIniSettingEx(strFileName As String, Section As String, Optional Key As String)
    Dim lRet As Long
    If Key = "" Then
        lRet = WritePrivateProfileString(Section, vbNullString, vbNullString, strFileName)
    Else
        lRet = WritePrivateProfileString(Section, Key, vbNullString, strFileName)
    End If
End Function

'------------------------------------------------------
' Function:   ValidFilename as string
' arguments:  strFilename         a filename
' Result: ValidFilename returns a valid filename
'-------------------------------------------------------
Function ValidFilename(strFileName As String) As String
    Dim i As Integer
    Dim strFname As String
    Dim legalChar As String
    ValidFilename = strFileName
    strFname = Trim(strFileName)       'remove white space
    ' Remove for illegal characters
    legalChar = " !#$%&'()-0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ^_`{}~."
    For i = 1 To Len(strFname)
        If InStr(legalChar, UCase(Mid(strFname, i, 1))) = 0 Then
            Mid(strFname, i, 1) = " "
        End If
    Next i
    ValidFilename = strFname
End Function
